﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Xors
{
    public static class Maths
    {
        /// <summary>
        /// Returns the XYZ component of the last xTFormPoint(), xTFormVector() or xTFormNormal() operation
        /// </summary>
        public static Vector3 TFormed
        {
            get
            {
                Vector3 v = new Vector3();
                v._x = Xors3d.TFormedX();
                v._y = Xors3d.TFormedY();
                v._z = Xors3d.TFormedZ();
                return v;
            }
        }

        /// <summary>
        /// Transforms vector between coordinate systems
        /// </summary>
        /// <param name="vec"></param>
        /// <param name="source"></param>
        /// <param name="destination"></param>
        public static void TFormNormal(Vector3 vec, Entity source, Entity destination)
        {
            Xors3d.TFormNormal(vec._x, vec._y, vec._z, source._handle, destination._handle);
        }

        /// <summary>
        /// Transforms vector between coordinate systems
        /// </summary>
        /// <param name="vec"></param>
        /// <param name="source"></param>
        /// <param name="destination"></param>
        public static void TFormPoint(Vector3 vec, Entity source, Entity destination)
        {
            Xors3d.TFormPoint(vec._x, vec._y, vec._z, source._handle, destination._handle);
        }

        /// <summary>
        /// Transforms vector between coordinate systems
        /// </summary>
        /// <param name="vec"></param>
        /// <param name="source"></param>
        /// <param name="destination"></param>
        public static void TFormVector(Vector3 vec, Entity source, Entity destination)
        {
            Xors3d.TFormVector(vec._x, vec._y, vec._z, source._handle, destination._handle);
        }

        /// <summary>
        /// Returns the pitch value of a vector
        /// </summary>
        /// <param name="vec"></param>
        /// <returns></returns>
        public static float VectorPitch(Vector3 vec)
        {
            return Xors3d.VectorPitch(vec._x, vec._y, vec._z);
        }

        /// <summary>
        /// Returns the yaw value of a vector
        /// </summary>
        /// <param name="vec"></param>
        /// <returns></returns>
        public static float VectorYaw(Vector3 vec)
        {
            return Xors3d.VectorYaw(vec._x, vec._y, vec._z);
        }
    }
}
