﻿namespace Xors.Physics
{
    public class Filtering
    {
        internal Entity _entity = null;

        /// <summary>
        /// Sets or get a collision filtering group of an entity. Default group is 0. Range between 0-31
        /// </summary>
        public int CollisionGroup
        {
            set
            {
                Xors3d.EntitySetCollisionGroup(_entity._handle, value);
            }
            get
            {
                return Xors3d.EntityGetCollisionGroup(_entity._handle);
            }
        }

        /// <summary>
        /// Sets or get a contact filtering group of an entity. Default group is 0. Range between 0-31
        /// </summary>
        public int ContactGroup
        {
            get
            {
                return Xors3d.EntityGetContactGroup(_entity._handle);
            }
            set
            {
                Xors3d.EntitySetContactGroup(_entity._handle, value);
            }
        }

        /// <summary>
        /// Sets a raycast filtering group of an entity. Default group is 0. Range between 0-31
        /// </summary>
        public int RaycastGroup
        {
            get
            {
                return Xors3d.EntityGetRaycastGroup(_entity._handle);
            }
            set
            {
                Xors3d.EntitySetRaycastGroup(_entity._handle, value);
            }
        }
    }
}
