﻿namespace Xors.Physics
{
    public class JointBall : Joint
    {
        /// <summary>
        /// Returns the XYZ coodinate of the pivot A of the 'ball' joint
        /// </summary>
        /// <param name="isGlobal">1 (true) to use global coordinates. 0 (false) to use local coordinates. Default is 0 (false)</param>
        /// <returns></returns>
        public Vector3 GetPivot(bool isGlobal = false)
        {
            Vector3 v = new Vector3();
            v._x = Xors3d.JointBallGetPivotX(_handle, isGlobal);
            v._y = Xors3d.JointBallGetPivotY(_handle, isGlobal);
            v._z = Xors3d.JointBallGetPivotZ(_handle, isGlobal);
            return v;
        }

        /// <summary>
        /// Sets the coordinates of the pivot of the 'ball' joint. Pivot A is a pivot of the first body connected to the second body by the given joint
        /// </summary>
        /// <param name="vec">coordinate of the joint's pivot </param>
        /// <param name="isGlobal">1 (true) to use global coordinates. 0 (false) to use local coordinates. Default is 0 (false)</param>
        public void SetPivot(Vector3 vec, bool isGlobal = false)
        {
            Xors3d.JointBallSetPivot(_handle, vec._x, vec._y, vec._z, isGlobal);
        }
    }
}
