﻿namespace Xors.Physics
{
    public class Whell
    {
        internal int _handle = 0;
        internal Entity _entity = null;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="index"></param>
        /// <returns></returns>
        public Entity GetContactEntity()
        {
            Entity ent = new Entity();
            ent._handle = Xors3d.EntityWheelGetContactEntity(_entity._handle, _handle);
            return ent._handle > 0 ? ent : null;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Vector3 GetRotation()
        {
            Vector3 v = new Vector3();
            v._x = Xors3d.EntityWheelGetPitch(_entity._handle, _handle);
            v._y = Xors3d.EntityWheelGetYaw(_entity._handle, _handle);
            v._z = Xors3d.EntityWheelGetRoll(_entity._handle, _handle);
            return v;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public float GetSuspensionLength()
        {
            return Xors3d.EntityWheelGetSuspensionLength(_entity._handle, _handle);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="axle"></param>
        public void SetAxle(Vector3 axle)
        {
            Xors3d.EntityWheelSetAxle(_entity._handle, _handle, axle._x, axle._y, axle._z);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="brake"></param>
        public void SetBrake(float brake)
        {
            Xors3d.EntityWheelSetBrake(_entity._handle, _handle, brake);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="vec"></param>
        /// <param name="isGlobal"></param>
        public void SetConnectionPoint(Vector3 vec, bool isGlobal = false)
        {
            Xors3d.EntityWheelSetConnectionPoint(_entity._handle, _handle, vec._x, vec._y, vec._z);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="force"></param>
        public void SetEngineForce(float force)
        {
            Xors3d.EntityWheelSetEngineForce(_entity._handle, _handle, force);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="friction"></param>
        public void SetFriction(float friction)
        {
            Xors3d.EntityWheelSetFriction(_entity._handle, _handle, friction);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="force"></param>
        public void SetMaxSuspensionForce(float force)
        {
            Xors3d.EntityWheelSetMaxSuspensionForce(_entity._handle, _handle, force);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="force"></param>
        public void SetMaxSuspensionTravel(float travel)
        {
            Xors3d.EntityWheelSetMaxSuspensionTravel(_entity._handle, _handle, travel);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="radius"></param>
        public void SetRadius(float radius)
        {
            Xors3d.EntityWheelSetRadius(_entity._handle, _handle, radius);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="ray"></param>
        public void SetRay(Vector3 ray)
        {
            Xors3d.EntityWheelSetRay(_entity._handle, _handle, ray._x, ray._y, ray._z);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="roll"></param>
        public void SetRollInfluence(float roll)
        {
            Xors3d.EntityWheelSetRollInfluence(_entity._handle, _handle, roll);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="rot"></param>
        public void SetRotation(float rot)
        {
            Xors3d.EntityWheelSetRotation(_entity._handle, _handle, rot);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="steering"></param>
        public void SetSteering(float steering)
        {
            Xors3d.EntityWheelSetSteering(_entity._handle, _handle, steering);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="compression"></param>
        public void SetSuspensionCompression(float compression)
        {
            Xors3d.EntityWheelSetSuspensionCompression(_entity._handle, _handle, compression);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="damping"></param>
        public void SetSuspensionDamping(float damping)
        {
            Xors3d.EntityWheelSetSuspensionDamping(_entity._handle, _handle, damping);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="length"></param>
        public void SetSuspensionLength(float length)
        {
            Xors3d.EntityWheelSetSuspensionLength(_entity._handle, _handle, length);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="value"></param>
        public void SetSuspensionStiffness(float value)
        {
            Xors3d.EntityWheelSetSuspensionStiffness(_entity._handle, _handle, value);
        }
    }

}
