﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Xors
{
    public class PostEffect
    {
        internal int _handle = 0;

        public bool equals(PostEffect value)
        {
            return value._handle == _handle;
        }

        /// <summary>
        /// Frees loaded post-effect. 
        /// This commands automaticaly delete post-effect from effects sequence 
        /// </summary>
        public void Free()
        {
            Xors3d.FreePostEffect(_handle);
        }

        public void SetEffectInt(string name, int value)
        {
            Xors3d.SetPostEffectInt(_handle, name, value);
        }

        public void SetEffectFloat(string name, float value)
        {
            Xors3d.SetPostEffectFloat(_handle, name, value);
        }

        public void SetEffectBool(string name, bool value)
        {
            Xors3d.SetPostEffectBool(_handle, name, value);
        }

        public void SetEffectVector(string name, Vector3 vec, float w=1)
        {
            Xors3d.SetPostEffectVector(_handle, name, vec._x, vec._y, vec._z, w);
        }

        public void SetEffectTexture(string name, Texture texture, int frame = 0)
        {
            Xors3d.SetPostEffectTexture(_handle, name, texture._handle, frame);
        }

        public void DeletePostEffectConstant(string name)
        {
            Xors3d.DeletePostEffectConstant(_handle, name);
        }

        public void ClearPostEffectConstants()
        {
            Xors3d.ClearPostEffectConstants(_handle);
        }
    }
}
