﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Xors
{
    public static class PostEffects
    {
        /// <summary>
        /// Loads new post-effect from file and returns it's handle
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public static PostEffect LoadPostEffect(string path)
        {
            PostEffect pe = new PostEffect();
            pe._handle = Xors3d.LoadPostEffect(path);
            return pe._handle > 0 ? pe : null;
        }

        /// <summary>
        /// Adds post-effect in sequence to post-processing. 
        /// Post-effects applies in index order 
        /// </summary>
        /// <param name="index"></param>
        /// <param name="postEffect"></param>
        /// <param name="technique"></param>
        public static void SetPostEffect(int index, PostEffect postEffect, string technique = "MainTechnique")
        {
            Xors3d.SetPostEffect(index, postEffect._handle, technique);
        }

        /// <summary>
        /// Renders all post-effects sequence
        /// </summary>
        public static void RenderPostEffects()
        {
            Xors3d.RenderPostEffects();
        }

    }
}
