﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Xors
{
    public static class ShaderEffects
    {
        /// <summary>
        /// Loads an effect from file. 
        /// Xors3D supports DirectX effects files (it uses HLSL as shaders language), it's more powerful and easy to use than regular shaders, you can change render states manually, make multi-pass effects and much more
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public static Effect LoadFXFile(string path)
        {
            Effect effect = new Effect();
            effect._handle = Xors3d.LoadFXFile(path);
            return effect._handle > 0 ? effect : null;
        }

        /// <summary>
        /// create poly for posteffect
        /// </summary>
        /// <param name="camera"></param>
        /// <param name="mode"></param>
        /// <returns></returns>
        public static PostEffectPoly CreatePostEffectPoly(Camera camera, int mode)
        {
            PostEffectPoly p = new PostEffectPoly();
            p._handle = Xors3d.CreatePostEffectPoly(camera._handle, mode);
            return p._handle > 0 ? p : null;
        }
    }
}
