﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Xors
{
    public class SpriteEntity : Entity
    {
        /// <summary>
        /// Sets the view mode of a sprite. 
        /// The view mode determines how a sprite alters its orientation in respect to the camera. This allows the sprite to in some instances give the impression that it is more than two dimensional. See 'Sprite view modes' for more infromation. Note that if you use sprite view mode FREE, then because it is independent from the camera, you will only be able to see it from one side unless you use xEntityFX() flag DISABLECULLING with it to disable backface culling. 
        /// </summary>
        /// <param name="mode"></param>
        public void SetSpriteViewMode(SpriteEntityViewMode mode)
        {
            Xors3d.SpriteViewMode(_handle, (int)mode);
        }

        /// <summary>
        /// Sets a sprite handle. Defaults to 0, 0. 
        /// By default sprite extends from -1, -1 to +1, +1. 
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        public void SetHandle(float x, float y)
        {
            Xors3d.HandleSprite(_handle, x, y);
        }

        public void Rotate(float angle)
        {
            Xors3d.RotateSprite(_handle, angle);
        }

        public void Scale(float x, float y)
        {
            Xors3d.ScaleSprite(_handle, x, y);
        }
    }
}
