﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Xors
{
    public static class SystemInformation
    {
        public static string CpuName()
        {
            return Xors3d.CPUName();
        }

        public static string CpuVendor()
        {
            return Xors3d.CPUVendor();
        }

        public static int CpuFamily()
        {
            return Xors3d.CPUFamily();
        }

        public static int CpuModel()
        {
            return Xors3d.CPUModel();
        }

        public static int CpuStepping()
        {
            return Xors3d.CPUStepping();
        }

        public static int CpuSpeed()
        {
            return Xors3d.CPUSpeed();
        }

        public static string VideoInfo()
        {
            return Xors3d.VideoInfo();
        }

        /// <summary>
        /// Returns an aspect ratio of the monitor as a float. 
        /// For instance, if your monitor is 5:4 this function will return 1.25
        /// </summary>
        /// <returns></returns>
        public static float VideoAspectRatio()
        {
            return Xors3d.VideoAspectRatio();
        }

        /// <summary>
        /// Returns an aspect ratio of the monitor as a string. 
        /// For instance, if your monitor is 5:4 this function will return "5:4"; 
        /// </summary>
        /// <returns></returns>
        public static string VideoAspectRatioStr()
        {
            return Xors3d.VideoAspectRatioStr();
        }

        public static float GetTotalPhysMem()
        {
            return Xors3d.GetTotalPhysMem();
        }

        public static float GetAvailPhysMem()
        {
            return Xors3d.GetAvailPhysMem();
        }

        public static float GetTotalPageMem()
        {
            return Xors3d.GetTotalPageMem();
        }

        public static float GetAvailPageMem()
        {
            return Xors3d.GetAvailPageMem();
        }

        public static float GetTotalVidMem()
        {
            return Xors3d.GetTotalVidMem();
        }

        public static float GetAvailVidMem()
        {
            return Xors3d.GetAvailVidMem();
        }

        public static float GetTotalVidLocalMem()
        {
            return Xors3d.GetTotalVidLocalMem();
        }

        public static float GetAvailVidLocalMem()
        {
            return Xors3d.GetAvailVidLocalMem();
        }

        public static float GetTotalVidNonLocalMem()
        {
            return Xors3d.GetTotalVidNonlocalMem();
        }

        public static float GetAvailVidNonLocalMem()
        {
            return Xors3d.GetAvailVidNonlocalMem();
        }

        /// <summary>
        /// Returns the version of Xors3d in format "XX.YY.ZZ" (major.minor.revision). 
        /// </summary>
        /// <returns></returns>
        public static string GetXors3DVersion()
        {
            return Xors3d.GetXors3dVersion();
        }

        public static int GetXors3dMajorVersion()
        {
            return Xors3d.GetXors3dMajorVersion();
        }

        public static int GetXors3dMinorVersion()
        {
            return Xors3d.GetXors3dMinorVersion();
        }

        public static int GetXors3dRevision()
        {
            return Xors3d.GetXors3dRevision();
        }
    }
}
