﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Xors
{
    public class TerrainTexture
    {
        internal int _handle = 0;

        public bool equals(TerrainTexture value)
        {
            return value._handle == _handle;
        }

        /// <summary>
        /// Frees the streaming terrain texture
        /// </summary>
        public void Free()
        {
            Xors3d.FreeTerrainTexture(_handle);
        }

        /// <summary>
        /// Enables or disables lightmap used for the streaming texture
        /// </summary>
        public bool LightMap
        {
            set
            {
                Xors3d.TerrainTextureLightmap(_handle, value);
            }
        }
    }
}
