﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Xors
{
    public class World
    {
        internal int _handle = 0;

        public bool equals(World value)
        {
            return value._handle == _handle;
        }

        public void Delete()
        {
            Xors3d.DeleteWorld(_handle);
        }

        public void SetFrequency(float value)
        {
            Xors3d.WorldSetFrequency(value, _handle);
        }

        public Vector3 Gravity
        {
            set
            {
                Xors3d.WorldSetGravity(value._x, value._y, value._z, _handle);
            }
            get
            {
                Vector3 v = new Vector3();
                v._x = Xors3d.WorldGetGravityX(_handle);
                v._y = Xors3d.WorldGetGravityY(_handle);
                v._z = Xors3d.WorldGetGravityZ(_handle);
                return v;
            }
        }

        public void SetAmbientLight(Color color)
        {
            Xors3d.AmbientLight(color._red, color._green, color._blue, _handle);
        }
    }
}
