﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Xors
{
    public static class Worlds
    {

        /// <summary>
        /// Creates a new world and returns its handle. 
        /// You can create several worlds, and then all the functions, such as xRenderWorld() or functions for creation and loading of meshes, will affect the current active world. Upon initialization, the engine creates a single primary world. It can be obtained with xGetDefaultWorld() and can not be deleted. 
        /// </summary>
        /// <returns></returns>
        public static World CreateWorld()
        {
            World world = new World();
            world._handle = Xors3d.CreateWorld();
            return world._handle > 0 ? world : null;
        }

        /// <summary>
        /// Returns a current active world
        /// </summary>
        public static World ActiveWorld
        {
            set
            {
                Xors3d.SetActiveWorld(value._handle);
            }
            get
            {
                World world = new World();
                world._handle = Xors3d.GetActiveWorld();
                return world._handle > 0 ? world : null;
            }
        }

        public static World GetDefaultWorld()
        {
            World world = new World();
            world._handle = Xors3d.GetDefaultWorld();
            return world._handle > 0 ? world : null;
        }
    }
}
